Imports system.text.regularexpressions

Public Class Form1
    'This code is under GPL.
    'You can edit and distribute on any purpose.
    '
    'First writer of this code-> JA7TDO ja7tdo@zao.jp 2007.11.15
    'Please add your sign bellow.
    '
    'AD9834 + FT245RL
    '
    'setting frequency is saved now. 2008.12.30 by JA7TDO
    '
    '
    '
    '
    '
    '
    '
    '






    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ftstatus = FT_ListDevices(numDevs, "", FT_LIST_NUMBER_ONLY)

        'While ftstatus <> FT_OK

        If numDevs > 0 Then
            ftstatus = Open_USB_Device_By_Serial_Number(My_serial)
        Else
            ftstatus = FT_Open(0, lngHandle)
        End If
        ftstatus = FT_SetBitMode(lngHandle, &H7, 1)
        ftstatus = FT_SetBaudRate(lngHandle, 30000)


        Frequency.Text = My.Settings.f0
        TrackBar1.Value = My.Settings.f0 * 100
        NumericUpDown1.Value = My.Settings.delta_f
        'RichTextBox1.Text = My.Settings.delta_f

        f0 = Frequency.Text
        Frequency.Text = Format(f0, "##.#####0")

        If ftstatus <> FT_OK Then
            LoggerList = "Open Failed status=" & ftstatus
            echo.Text = LoggerList
            write.Enabled = False
            Exit Sub
        Else
            echo.Text = "Success!" & numDevs & FT_LIST_NUMBER_ONLY & FT_OPEN_BY_SERIAL_NUMBER
            write.Enabled = True
        End If

        ftstatus = FT_Close(lngHandle)

        ' End While


    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles write.Click
        SetDatas(Val(Frequency.Text))
        SetFrequency(Trim(send_freq))
        TrackBar1.Value = Val(Frequency.Text) * 100
        echo.Text = SendText
    End Sub
    Private Sub Form1_Close(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ftstatus = FT_Close(lngHandle)
        My.Settings.f0 = Val(Frequency.Text)
        My.Settings.MCLK = NumericUpDown2.Value
        My.Settings.delta_f = NumericUpDown1.Value
        My.Settings.Save()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        Close()

    End Sub

    Private Sub Form1_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Activated

        Frequency.Select()

    End Sub
    Private Sub Frequency_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Frequency.MouseWheel
        'wheel control
        Dim i As Integer
        Dim SendData As String = ""

        WheelValue = e.Delta

        If WheelValue > 1 Then
            i = delta_f
        ElseIf WheelValue < -1 Then
            i = delta_f * -1
        End If

        If Val(Frequency.Text) >= Upper_freq Then
            Frequency.Text = Upper_freq - 0.001
        End If

        If Val(Frequency.Text) < Lower_freq Then
            Frequency.Text = Lower_freq
        End If

        Frequency.Text = Val(Frequency.Text) + (i / 1000)
        Frequency.Text = Format(Val(Frequency.Text), "##.#####0")
        lngBytesWritten = 0

        If Val(Frequency.Text) * 100 < TrackBar1.Maximum Or Val(Frequency.Text) * 100 > TrackBar1.Minimum Then

            TrackBar1.Value = Val(Frequency.Text) * 100

        ElseIf Val(Frequency.Text) * 100 >= TrackBar1.Maximum Then

            TrackBar1.Value = TrackBar1.Maximum

        ElseIf Val(Frequency.Text) * 100 <= TrackBar1.Minimum Then

            TrackBar1.Value = TrackBar1.Minimum

        End If


        SetDatas(Val(Frequency.Text))

        SetFrequency(send_freq)

        write.Enabled = True

        RichTextBox1.Text = Lower_freq

        My.Settings.f0 = Val(Frequency.Text)
        ' My.Settings.Save()


    End Sub

    Private Sub NumericUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown1.ValueChanged
        delta_f = NumericUpDown1.Value
        My.Settings.delta_f = Val(delta_f)
        'My.Settings.Save()

    End Sub

    Private Sub NumericUpDown2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown2.ValueChanged

        MCLK = NumericUpDown2.Value * 1000000
        If MCLK < 5000000 Then
            MCLK = 50000000
        End If

        RichTextBox1.Text = NumericUpDown2.Value
    End Sub


    Private Sub Frequency_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Frequency.TextChanged
        If Regex.IsMatch(Frequency.Text, "[0-9.]") = False Then
            Beep()
            echo.Text = "error please input 0-9"
        End If
        Frequency.Focus()

    End Sub

    Private Sub RichTextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RichTextBox1.TextChanged

    End Sub

   Private Sub Label7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked = True Then
            initialize0(4) = 0
            SetDatas(Val(Frequency.Text))
            SetFrequency(Trim(send_freq))
        End If

        If CheckBox1.Checked = False Then
            initialize0(4) = 1
            SetDatas(Val(Frequency.Text))
            SetFrequency(Trim(send_freq))
        End If


    End Sub

    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        If CheckBox2.Checked = True Then
            L_or_M = True
        End If
        If CheckBox2.Checked = False Then
            L_or_M = False
        End If
    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        Dim f_track As Decimal

        f_track = TrackBar1.Value / 100
        Frequency.Text = Format(f_track, "##.#####0")

        If TrackBar1.Focus = True Then
            SetDatas(Val(Frequency.Text))
            SetFrequency(Trim(send_freq))
            write.Enabled = True
        End If
    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        If RadioButton1.Checked = True Then
            Lower_freq = 0.1
            Upper_freq = 8.0
            TrackBar1.Maximum = 800
            TrackBar1.Minimum = 10
            CheckBox3.Visible = False

        End If
    End Sub

    Private Sub RadioButton3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton3.CheckedChanged
        If RadioButton3.Checked = True Then
            Lower_freq = 0.5
            Upper_freq = 70
            TrackBar1.Maximum = 7000
            TrackBar1.Minimum = 50
            CheckBox3.Visible = True
        End If
    End Sub

    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
        If RadioButton2.Checked = True Then
            Lower_freq = 2.5
            Upper_freq = 30.0
            TrackBar1.Maximum = 3000
            TrackBar1.Minimum = 250
            CheckBox3.Visible = False
        End If
    End Sub

    Private Sub CheckBox3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox3.CheckedChanged
        If CheckBox3.Checked = True Then
            bpf = True
            SetDatas(Val(Frequency.Text))
            SetFrequency(Trim(send_freq))
        Else
            bpf = False
            SetDatas(Val(Frequency.Text))
            SetFrequency(Trim(send_freq))

        End If
    End Sub
End Class
